// SimpleEventsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SimpleEvents.h"
#include "SimpleEventsDlg.h"

#include <Accctrl.h>
#include <Aclapi.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimpleEventsDlg dialog

CSimpleEventsDlg::CSimpleEventsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimpleEventsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSimpleEventsDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSimpleEventsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimpleEventsDlg)
	DDX_Control(pDX, IDC_TREE_WINDOW_DESKTOPS, m_WinDesktops);
	DDX_Control(pDX, IDC_TREE_WINDOW_STATIONS, m_WinStations);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSimpleEventsDlg, CDialog)
	//{{AFX_MSG_MAP(CSimpleEventsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PUT_IN_CLIPBOARD, OnButtonPutInClipboard)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_WINDOW_STATIONS, OnSelchangedTreeWindowStations)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimpleEventsDlg message handlers

BOOL CSimpleEventsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSimpleEventsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSimpleEventsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSimpleEventsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL _stdcall EnumWindowStationProc(LPSTR lpszWindowStation, LPARAM lParam)
{
	// ::MessageBox(NULL, lpszWindowStation, "Window Station", MB_OK);

	CTreeCtrl* myTree = (CTreeCtrl* )lParam;

	myTree->InsertItem(lpszWindowStation);

	return TRUE;
}

BOOL _stdcall EnumDesktopProc(LPSTR lpszDesktop, LPARAM lParam)
{
	CTreeCtrl* myTree = (CTreeCtrl* )lParam;

	myTree->InsertItem(lpszDesktop);

	return TRUE;
}

void CSimpleEventsDlg::OnButtonPutInClipboard() 
{
	// TODO: Add your control notification handler code here
	m_WinStations.DeleteAllItems();
	::EnumWindowStations(&EnumWindowStationProc, (LPARAM )&m_WinStations);

}

void CSimpleEventsDlg::OnSelchangedTreeWindowStations(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	HWINSTA hWinSta;
	PSID ppsidOwner;
	PSID ppsidGroup;
	PACL ppDacl;
	PACL ppSacl;
	PSECURITY_DESCRIPTOR  ppSecurityDescriptor;
	DWORD result;

	char* str = new char[200];
	strcpy(str, (LPCTSTR )m_WinStations.GetItemText(pNMTreeView->itemNew.hItem)); //wow, bug overflow.
	
	hWinSta = OpenWindowStation(str, TRUE, GENERIC_READ);

	result = GetSecurityInfo(hWinSta, 
			SE_WINDOW_OBJECT, 
			DACL_SECURITY_INFORMATION,
			&ppsidOwner,
			&ppsidGroup,
			&ppDacl,
			&ppSacl,
			&ppSecurityDescriptor);

	if ( result != ERROR_SUCCESS )
	{
		::MessageBox(NULL, "Problem with GetSecurityInfo()", "GetSecInfo", MB_OK);
	}
	else
	{
		m_WinDesktops.DeleteAllItems();
		::EnumDesktops(hWinSta, &EnumDesktopProc, (LPARAM )&m_WinDesktops);	
	}

	delete [] str;
	*pResult = 0;
}
